#if !defined(AFX_CHILDVIEW_H__673A0418_11F9_4001_8E8F_C048406622A9__INCLUDED_)
#define AFX_CHILDVIEW_H__673A0418_11F9_4001_8E8F_C048406622A9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define CV_SINGLEWAVE 0
#define CV_WORKSPACE  1

struct Peaks
{
	SHORT L_hi;
	SHORT L_lo;
	SHORT R_hi;
	SHORT R_lo;
};

class CChildView : public CWnd
{
// Construction
public:
	CChildView();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildView)
	public:
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	void AttachEngine(WaveEngine* _pEngine, WavePlayer* _pPlayer);
	void ResetView(int waveNumber);
	void DoNotMove(void);
	Peaks GetPeaksInRange(DWORD start, double step, bool mode);
	virtual ~CChildView();
	DWORD GetViewedDataSize(void);
	DWORD GetSelectionStart(void);
	DWORD GetSelectionLength(void);
	DWORD GetDispStart(void);
	DWORD GetDispLength(void);
	bool  isWorkspaceDisplayed(void);

	// Generated message map functions
protected:
	//{{AFX_MSG(CChildView)
	afx_msg void OnPaint();
	afx_msg void OnViewWorkspace();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditDelete(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBarZoomin(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBarZoomout(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBarShowall(CCmdUI* pCmdUI);
	afx_msg void OnBarZoomin();
	afx_msg void OnBarShowall();
	afx_msg void OnBarZoomout();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditDelete();
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateViewWorkspace(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:

	HBRUSH	hBgBrush;

	bool WorkspaceView;
	UCHAR Wave;
	
	WaveEngine*	pEngine;
	WavePlayer* pPlayer;

	CPen pen_1, pen_2; //1 - zielony, 2-bialy

	DWORD DisplayStart;
	DWORD DisplayLength;

	DWORD SelectionStart;
	DWORD SelectionLength;
	int WhereLastClicked;
	//Ta zmienna wykorzystywana jest do sprawdzania, czy potrzeba odrysowac caly widok.
	bool DrawWave;
	bool MoveInactive;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDVIEW_H__673A0418_11F9_4001_8E8F_C048406622A9__INCLUDED_)
