#include "stdafx.h"
#include "wavefile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

WaveFile::WaveFile()
{
	size = 0;
	name[0] = 0;
	hFile = 0;
	isOpen = false;
}

WaveFile::~WaveFile()
{
	Close();
}

bool WaveFile::Open(const char* fName, bool mode)
{
	isOpen = false;

	if (mode == WF_READ)
	{
		hFile = CreateFile(fName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_FLAG_RANDOM_ACCESS, 0);
		if (hFile == INVALID_HANDLE_VALUE) return false;
		else
		{
			CopyMemory(name, fName, strlen(fName) + 1);
			size = GetFileSize(hFile, NULL); // null, czyli plik nie wiekszy niz 4BG.
		}

		ReadFile(hFile, buffer, 44, &LastRead, NULL);
		if ( ((WORD)(buffer[20] != 1)) || ((WORD)(buffer[22] != 2)) || ((DWORD)(buffer[34] != 16)))
		{
			Close();
			return false;
		}
	}
	else if (mode == WF_WRITE)
	{
		hFile = CreateFile(fName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
		if (hFile == INVALID_HANDLE_VALUE) return false;
		else
		{
			size = 0;
			CopyMemory(name, fName, strlen(fName) + 1);
		}
	}

	isOpen = true;
	return true;
}

void WaveFile::Close(void)
{
	CloseHandle(hFile);

	isOpen = false;
	DWORD size = 0;
}

DWORD WaveFile::GetDataBlock(char* buff, DWORD size)
{
	if(isOpen)
	{
		ReadFile(hFile, buff, size << 2, &LastRead, NULL);
		return LastRead >> 2; // Czyli sample, a nie bajty!
	}
	else return NULL;
}

void WaveFile::Seek(DWORD pos)
{
	DWORD x;
	x = SetFilePointer(hFile, 44 + (pos << 2), 0, FILE_BEGIN);
}

DWORD WaveFile::GetDataSize(void)
{
	if (isOpen) return (GetFileSize(hFile, 0) - 44) >> 2 ;
	//Dzielimy na 4, bo jeden sampel stereo/16b zajmuje 4 bajty.
	else return 0;
	
}

DWORD WaveFile::PutDataBlock(char* buff, DWORD size)
{
	if (isOpen)
	{
		WriteFile(hFile, buff, size << 2, &LastWritten, 0);
		return LastWritten >> 2;
	}
	else return false;

}

bool WaveFile::WriteHeader(DWORD size)
{
	DWORD last;
	DWORD dWord;
	WORD Word;

	if (isOpen)
	{
		WriteFile(hFile, (void*)"RIFF", 4, &last, 0);
		dWord = (size << 2) + 36;
		WriteFile(hFile, (void*)(&dWord), 4, &last, 0);
		WriteFile(hFile, (void*)"WAVE", 4, &last, 0);
		WriteFile(hFile, (void*)"fmt ", 4, &last, 0);
		dWord = 16;
		WriteFile(hFile, (void*)(&dWord), 4, &last, 0);
		dWord = 1;
		WriteFile(hFile, (void*)(&dWord), 2, &last, 0);
		Word = 2;
		WriteFile(hFile, (void*)(&Word), 2, &last, 0);
		dWord = 44100;
		WriteFile(hFile, (void*)(&dWord), 4, &last, 0);
		dWord = 44100*4;
		WriteFile(hFile, (void*)(&dWord), 4, &last, 0);
		Word = 4;
		WriteFile(hFile, (void*)(&Word), 2, &last, 0);
		Word = 16;
		WriteFile(hFile, (void*)(&Word), 2, &last, 0);
		WriteFile(hFile, (void*)"data", 4, &last, 0);
		dWord = (size << 2);
		WriteFile(hFile, (void*)(&dWord), 4, &last, 0);
	
		return true;
	}
	else return false;
}